diff --git a/lang/en/local_contrib.php b/lang/en/local_contrib.php
index ec70f6d..829e2e4 100644
--- a/lang/en/local_contrib.php
+++ b/lang/en/local_contrib.php
@@ -3,7 +3,7 @@
 /**
  * This file contains the English language strings for this plugin.
  *
- * Thie file is part of the local_contrib plugin, a plugin designed
+ * This file is part of the local_contrib plugin, a plugin designed
  * to manage plugins contributed by the Moodle community.
  *
  * @package local_contrib
@@ -25,7 +25,7 @@ $string['adddocumentation'] = 'Add documentation';
 $string['addfaqs'] = 'Add FAQ\'s';
 $string['addnewversion'] = 'Add a new version';
 $string['addnewversion_desc'] = '<p>When adding a new version you only need to upload the new version file and select the previous version, we will try to do the rest for you.
-Once you click Sumbit and the file has uploaded we will unzip it and look for some key files that most Moodle plugins have and will collect information about this version from them.
+Once you click Submit and the file has uploaded we will unzip it and look for some key files that most Moodle plugins have and will collect information about this version from them.
 The following are the files that will be inspected as part of this process and the information we are hoping to find:</p>
 
 <p><strong>version.php</strong></p>
@@ -41,7 +41,7 @@ The following are the files that will be inspected as part of this process and t
 RELEASENOTES<br />
 README.txt<br />
 README</strong><br />
-<span>If any of these files exist they are used as the release notes for this version. First we search for RELEASENOTES files and if they don\'t exist we search for README files.</span>
+<span>If any of these files exist they are used as the release notes for this version. First we search for RELEASENOTES files and if they do not exist we search for README files.</span>
 </p>
 
 Once we have collected all the information we can the new version will be added at which point you can double check the information is correct and edit the version to add any extra or missing information you want.';
@@ -148,7 +148,7 @@ $string['editosoftwareversion'] = 'Edit software version';
 $string['enablethisplugin'] = 'Enable this plugin';
 $string['experimental'] = 'Experimental';
 $string['externaldocurl'] = 'External documentation URL';
-$string['externaldocurllink'] = 'More documenation on this plugin can be found at ';
+$string['externaldocurllink'] = 'More documentation on this plugin can be found at ';
 $string['faqs'] = 'FAQs';
 $string['faqsupdated'] = 'The FAQ\'s for this plugin have been successfully updated';
 $string['frontpageawards'] = 'Awards to display on the front page';
@@ -193,7 +193,7 @@ $string['nodocumenation'] = 'No documentation has been written for this plugin y
 $string['nofaqs'] = 'No frequently asked questions have been written for this plugin yet.';
 $string['none'] = 'None';
 $string['noreviewcriteria'] = 'No review criteria have been created yet.';
-$string['nopluginawards'] = 'This plugin hasn\'t recieved any awards yet';
+$string['nopluginawards'] = 'This plugin has not received any awards yet';
 $string['nopluginreviews'] = 'No one has reviewed this plugin yet.';
 $string['nopluginsets'] = 'This plugin is not yet in any sets';
 $string['nosets'] = 'There are not yet any plugin sets.';
@@ -265,7 +265,7 @@ $string['showemptycategories'] = 'Show empty categories';
 $string['showemptycategoriesdesc'] = 'If set to true categories that don\'t have any plugins will be shown on the navigation and category listings';
 $string['software'] = 'Software';
 $string['softwareversion'] = 'Software version';
-$string['softwareversion_help'] = 'This is the verion number of the software release. In the case of Moodle this is the version number in version.php, in the case of PHP this is just the release number e.g. 5.3.2';
+$string['softwareversion_help'] = 'This is the version number of the software release. In the case of Moodle this is the version number in version.php, in the case of PHP this is just the release number e.g. 5.3.2';
 $string['softwareversionoption'] = '{$a->name} {$a->releasename} ({$a->version})'; //MIM TODO (what if version is empty)
 $string['sourcecontrolurl'] = 'Source control URL';
 $string['sourcecontrolurl_help'] = 'If you use a public repository for all of your work on this plugin please enter its URL here.';
@@ -296,7 +296,7 @@ $string['vcsbranch_help'] = 'If this versions of the plugin is on a particular b
 $string['vcsrepositoryurl'] = 'VCS repository URL';
 $string['vcsrepositoryurl_help'] = 'This should be the URL to the public repository you used.';
 $string['vcssystem'] = 'Version control system (VCS)';
-$string['vcssystem_help'] = 'This is the <b>V</b>ersion <b>C</b>ontrol <b>S</b>ystem that you use to track your development efforts on this version of the plugin. Please select the CVS you use or alternativily select other and tell us which one you use.';
+$string['vcssystem_help'] = 'This is the <b>V</b>ersion <b>C</b>ontrol <b>S</b>ystem that you use to track your development efforts on this version of the plugin. Please select the CVS you use or alternatively select other and tell us which one you use.';
 $string['vcssystemother'] = 'Other...';
 $string['vcstag'] = 'VCS tag';
 $string['vcstag_help'] = 'If this version was given a particular tag you should enter the tag name here.';
@@ -318,7 +318,7 @@ $string['viewallincategory'] = 'View all plugins in this category';
 $string['viewallinset'] = 'View all plugins in this set';
 $string['website'] = 'Website';
 $string['websiteurl'] = 'Website URL';
-$string['websiteurl_help'] = 'If you have a website set up that has more information about your plugin or your work you can put it\'s URL here.';
+$string['websiteurl_help'] = 'If you have a website set up that has more information about your plugin or your work you can put its URL here.';
 $string['writereview'] = 'Write a review';
 
 /**
@@ -405,4 +405,4 @@ $string['contrib:addtosets']              = 'Add contributed plugins to sets';
 $string['contrib:manageawards']           = 'Manage awards for contributed plugins';
 $string['contrib:handoutawards']          = 'Hand out awards for contributed plugins';
 $string['contrib:managecategories']       = 'Manage categories for contributed plugins';
-$string['contrib:managereviewcriteria']   = 'Manage review criterias for contributed plugins';
+$string['contrib:managereviewcriteria']   = 'Manage review criteria for contributed plugins';